# -*- coding: cp1252 -*-
import PyTango
import time
import zmq
import Timer
import numpy

print PyTango.__version__

class TestDeviceImpl(PyTango.Device_4Impl):

    def __init__(self,cl,name):
        PyTango.Device_4Impl.__init__(self,cl,name)
        self.debug_stream('In PyDsExp __init__')
        self.init_device()
        
    def init_device(self):
        self.bCritical = False
        
        self.timerPush = Timer.ResettableTimer(1.,self.PushValues)

        self.CreateAttribut()
        
        self.timerRecreate = Timer.ResettableTimer(5.,self.ResetAttr)

    def CreateAttribut(self):
        print "CreateAttribut"
        attrMOD = PyTango.ImageAttr("MOD1", PyTango.ArgType.DevDouble, PyTango.AttrWriteType.READ, 10, 10)
        self.add_attribute(attrMOD)
        self.set_change_event("MOD1", True, False)
        
    def RemoveAttribut(self):
        print "Remove"
        self.remove_attribute("MOD1")
        time.sleep(2.0)

    def ResetAttr(self):
        self.bCritical = True
        
        self.RemoveAttribut()
        self.CreateAttribut()

        #################### UNCOMMENT TO UNFREEZE THE SERVER #################################################
#         pyds = PyTango.DeviceProxy('tango/test/testdevice')
#         idEvent = pyds.subscribe_event("MOD1",PyTango.EventType.CHANGE_EVENT,self.PrintEvent, stateless = True)
#         pyds.unsubscribe_event(idEvent)
        #################### UNCOMMENT TO UNFREEZE THE SERVER #################################################

        self.bCritical = False
    
    def PrintEvent(self,event):
        print event
        
    def PushValues(self):
        if self.bCritical : return
        self.push_change_event("MOD1",numpy.random.random((2,2)))



        

